<?php
namespace nur\sery\file\csv;

use nur\sery\file\FileReader;
use nur\sery\php\time\Date;
use nur\sery\php\time\DateTime;

class CsvReader extends AbstractReader {
  function getIterator() {
    $reader = new FileReader($this->input);
    while (($row = $reader->fgetcsv()) !== null) {
      foreach ($row as &$col) {
        # conversion Date et DateTime
        if (DateTime::isa_datetime($col, true)) {
          $col = new DateTime($col);
        } elseif (DateTime::isa_date($col, true)) {
          $col = new Date($col);
        }
      }; unset($col);

      if ($this->cook($row)) {
        yield $row;
        $this->idest++;
      }
      $this->isrc++;
    }
    $reader->close();
  }
}
